Loading...
Searching...
No Matches
ConnectionProvider::FtpConnection Class Reference

class for FTP connections; returns Qore::FtpClient objects More...

`#include <FtpConnection.qc.dox.h>`

Inheritance diagram for ConnectionProvider::FtpConnection:
[legend]

## Public Member Functions

| constructor (string name, string description, string url, hash< auto > attributes={}, hash< auto > options={})
| creates the FtpConnection object
DataProvider::AbstractDataProvider | getDataProvider ()
| returns an FtpClientDataProvider object for this connection
*hash< auto > | getRuntimeOptions ()
| returns runtime options
string | getType ()
| returns `"ftp"`
bool | hasDataProvider ()
| returns True, as the connection returns a data provider with the getDataProvider() method
Public Member Functions inherited from ConnectionProvider::AbstractConnectionWithInfo
| constructor (string name, string description, string url, hash< auto > attributes={}, hash< auto > options={})
| creates the AbstractConnection object
hash< ConnectionSchemeInfo > | getConnectionSchemeInfo ()
| Returns the ConnectionSchemeInfo hash for this object.
*hash< auto > | getDefaultOptions ()
| returns default options
*hash< auto > | getOptions ()
| returns static / initialization options
Public Member Functions inherited from ConnectionProvider::AbstractConnection
deprecated | constructor (string name, string desc, string url, bool monitor, *hash opts, hash urlh, *string safe_url, *bool enabled)
| creates the AbstractConnection object
| constructor (string name, string description, string url, hash< auto > attributes={}, hash< auto > options={}, *LoggerInterface logger)
| creates the AbstractConnection object
object | get (bool connect=True, *hash< auto > rtopts)
| returns the underlying connection object
hash< ConfigInfo > | getConfigHash ()
| returns a ConfigInfo hash of static configuration information about the connection
hash< ConnectionSchemeInfo > | getConnectionSchemeInfo ()
| Returns a default ConnectionSchemeInfo hash.
hash< ConnectionSchemeInfo > | getConnectionSchemeInfoImpl ()
| Override in subclasses to return a native ConnectionSchemeInfo hash.
AbstractDataProvider | getDataProvider ()
| returns a data provider object for this connection, if supported
*hash< auto > | getDefaultOptions ()
| returns default options
string | getDescription ()
| Returns the connection description.
hash< auto > | getExtendedInfo (*hash< auto > opts)
| Returns connection info plus any extended information returned by the connection.
*hash< string, bool > | getFeatures ()
| Returns a list of connection-defined features.
hash< ConnectionInfo > | getInfo (*hash< auto > opts)
| returns a ConnectionInfo hash of information about the connection
hash< ConnectionInfo > | getInfo (bool with_password=False)
| returns a ConnectionInfo hash of information about the connection
string | getName ()
| Returns the connection name.
*hash< auto > | getOptions ()
| returns static / initialization options
object | getPollImpl ()
| Returns an unconnected object for a non-blocking poll operation.
*hash< auto > | getRealOptions ()
| returns options for saving the connection's configuration information
*hash< auto > | getRuntimeOptions ()
| returns runtime options
string | getSafeUrl ()
| Returns the connection safe URL (without password info)
auto | getTag (string tag)
| returns the value of the given tag or NOTHING if not present
auto | getTagEx (string tag)
| returns the value of the given tag or throws an exception if the tag is not set with a value
hash< auto > | getTags ()
| returns all tags associated with the connection
abstract string | getType ()
| returns the string type name for the connection object
string | getUrl ()
| Returns the connection URL.
| handlePingFailed (date delta, hash< ExceptionInfo > ex)
| Handles a failed ping operation on the connection.
| handlePingFailed (date delta, string err)
| Handles a failed ping operation on the connection.
| handlePingSuccess (date delta)
| Handles a successful ping operation on the connection.
bool | hasDataProvider ()
| returns True if the connection returns a data provider with the getDataProvider() method
| parseTextOptions ()
| this method is called when parsing connection file definitions from text files when loading into the database
hash< PingInfo > | ping (bool throw_exception=False)
| returns a hash with the results of the ping operation
Qore::AbstractPollOperation | startPollConnect ()
| Called to start the connection polling operation.
bool | supportsPollingApi ()
| returns True if the connection supports the Qore Socket-based polling API

## Public Attributes

const | ConnectionScheme
| Connection entry info.
Public Attributes inherited from ConnectionProvider::AbstractConnection
const | CF_LOGGER = "logger"
| Connection feature: Logger support.
const | CF_UPDATE_OPTIONS = "update-options"
| Connection feature: Update Options support.
bool | children_can_support_apis = False
| if the data provider or any of its children support requests (APIs)
bool | children_can_support_messages = False
| if the data provider or any of its children support messages
bool | children_can_support_observers = False
| if the data provider or any of its children support events
bool | children_can_support_records = False
| if the data provider or any of its children support records
bool | children_can_support_transactions = False
| if the data provider or any of its children support transaction management
bool | debug_data = False
| debug data flag; to be used an an indication for a higher-level implementation
string | desc
| connection description
bool | enabled = True
| enabled/disabled indicator flag
hash< auto > | internal_info
| internal tags (serializable)
date | last_check
| date/time of last check/ping
bool | locked = False
| locked/unlocked flag
bool | loopback = False
| set to True for loopback connections
bool | monitor
| monitoring flag
string | name
| connection name
*hash< auto > | opts
| connection options
*hash< auto > | orig_opts
| original connection options
string | safe_url
| "safe" URL (password information removed)
string | status = "not checked"
| status string; in case of a connection error this string will be the error string
hash< auto > | tags = {}
| connection tags; user-defined key-value pairs
transient hash< auto > | transient_info
| internal transient tags (non-serializable)
bool | up = True
| connection status flag; set by monitoring or explicit pings/connections
date | updated
| date/time of last update
string | url
| connection URL (potentially with password info)
hash< auto > | urlh
| broken down URL hash (as returned by Qore::parse_url())

## Protected Member Functions

hash< ConnectionSchemeInfo > | getConnectionSchemeInfoImpl ()
| Returns the ConnectionSchemeInfo hash for this object.
FtpClient | getImpl (bool connect=True, *hash< auto > rtopts)
| returns an Qore::FtpClient object
| setChildCapabilities ()
| Sets child data provider capabilities.
abstract hash< ConnectionSchemeInfo > | getConnectionSchemeInfoImpl ()
| Returns the ConnectionSchemeInfo hash for this object.
Protected Member Functions inherited from ConnectionProvider::AbstractConnection
*hash< string, bool > | getFeaturesImpl ()
| Returns a hash of connection-defined features.
abstract object | getImpl (bool connect=True, *hash< auto > rtopts)
| this method must return the connection object corresponding to the object's configuration
string | getSafeUrl (hash< auto > urlh)
| creates a "safe" URL string with password information removed
hash< UrlInfo > | parseUrl (string url)
| Parse the URL to a hash.
| pingImpl ()
| performs the internal ping
hash< PingInfo > | pingIntern (hash< PingInfo > rv)
| performs the ping by executing get(); returns a PingInfo hash
| setChildCapabilities ()
| Override to set child data provider capabilities once per child class.
hash< auto > | validateOptions (hash< auto > options)
| performs options validation in the constructor

## Additional Inherited Members

Static Public Attributes inherited from ConnectionProvider::AbstractConnection
static *code | post_processing
| optional code for default post-processing of objects created by getImpl()

## Detailed Description

class for FTP connections; returns Qore::FtpClient objects

supports the following runtime options in getImpl():

- `"path"`: overrides the path component in the URL at runtime
- `"path_add"`: appends the given string to the path component of the URL at runtime

## Member Function Documentation

## constructor()

ConnectionProvider::FtpConnection::constructor | ( | string | name,
|  | string | description,
|  | string | url,
|  | hash< auto > | attributes = `{}`,
|  | hash< auto > | options = `{}`
| ) |  |

creates the FtpConnection object

Parameters

  name | the name of the connection
  description | connection description
  url | connection URL (potentially with password info)
  attributes | various attributes. See below
  options | connection options

See AbstractConnection::constructor() for `attributes` and `options` reference.

Exceptions

  CONNECTION-OPTION-ERROR | missing or invalid connection option

## getDataProvider()

DataProvider::AbstractDataProvider ConnectionProvider::FtpConnection::getDataProvider | ( |  | ) |

returns an FtpClientDataProvider object for this connection

Returns
  an FtpClientDataProvider object for this connection

See also
  hasDataProvider()

## getImpl()

FtpClient ConnectionProvider::FtpConnection::getImpl | ( | bool | connect = `True`,
|  | *hash< auto > | rtopts
| ) |  |

protectedvirtual

returns an Qore::FtpClient object

Parameters

  connect | if True then a connection is made any if there is any path in the URL a `CWD` operation is performed to change to the target directory
  rtopts | this connection type does not accept any runtime option, so this parameter is ignored

Implements ConnectionProvider::AbstractConnection.

## getRuntimeOptions()

*hash< auto > ConnectionProvider::FtpConnection::getRuntimeOptions | ( |  | ) |

returns runtime options

return a hash with the following keys reflecting support for the corresponding runtime options in getImpl():

- `"path"`: overrides the path component in the URL at runtime
- `"path_add"`: appends the given string to the path component of the URL at runtime

## hasDataProvider()

bool ConnectionProvider::FtpConnection::hasDataProvider | ( |  | ) |

returns True, as the connection returns a data provider with the getDataProvider() method

Returns
  True, as the connection returns a data provider with the getDataProvider() method

See also
  getDataProvider()